import 'package:freezed_annotation/freezed_annotation.dart';
import 'package:imi/src/utils/app_config.dart';

import '../../../utils/enum.dart';

///
/// Code generated by jsonToDartModel https://ashamp.github.io/jsonToDartModel/
///
class LoginRequest {
  String? grantType;
  String? clientId;
  String? phone;
  String? otp;
  String? pin;
  OtpChannel? otpChannel;

  LoginRequest({
    this.phone,
    this.otp,
    this.pin,
    this.otpChannel,
  }) {
    this.grantType = "password";
    this.clientId = AppConfig.environment.clientId;
  }

  LoginRequest.fromJson(Map<String, dynamic> json) {
    grantType = json["grant_type"]?.toString();
    clientId = json["client_id"]?.toString();
    phone = json["phone"]?.toString();
    otp = json["otp"]?.toString();
    pin = json["pin"]?.toString();
    otpChannel = OtpChannel.values
        .firstWhereOrNull((element) => element.name == json['channel']);
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = Map<String, dynamic>();
    if (grantType != null) data["grant_type"] = grantType;
    if (clientId != null) data["client_id"] = clientId;
    if (phone != null) data["phone"] = phone;
    if (otp != null) data["otp"] = otp;
    if (pin != null) data["pin"] = pin;
    if (otpChannel != null) data["otp_channel"] = otpChannel?.name;
    return data;
  }
}
